package com.jasamedika.medifirst2000.entities;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.jasamedika.medifirst2000.base.BaseTransaction;
import com.jasamedika.medifirst2000.helper.Caption;import org.hibernate.envers.Audited;

@Entity //@Audited
@Table(name="PapInstruksiRanap_T")
public class PapInstruksiRanap extends BaseTransaction{
	@ManyToOne
	@JoinColumn(name = "ObjectRegistrasiPelayananPasienFk")
	//@NotNull(message = "RegistrasiPelayananPasien tidak boleh kosong")
	private RegistrasiPelayananPasien registrasiPelayananPasien;	
	
	@Column(name = "ObjectRegistrasiPelayananPasienFk", columnDefinition = "CHAR(32)", insertable = false, updatable = false, nullable = true)
	private String registrasiPelayananPasienId;

	@ManyToOne
	@JoinColumn(name = "ObjectPasienFk")
	@NotNull(message = "Pasien tidak boleh kosong")
	private Pasien pasien;	
	
	@Column(name = "ObjectPasienFk", insertable = false, updatable = false, nullable = false)
	private Integer pasienId;
	
	@NotNull(message = "Tgl Input tidak boleh kosong")
	@Column(name = "tglInput", nullable = false)
	@Caption(value = "Tgl Input")
	private Date tglInput;

	@ManyToOne
	@JoinColumn(name = "ObjectKondisiPasienFk")
	@Caption(value="Object kondisiPasien")
	private GenericView kondisiPasien;

	@Column(name = "ObjectKondisiPasienFk", insertable = false, updatable = false, nullable = false)
	private Integer kondisiPasienId;

	@ManyToOne
	@JoinColumn(name = "ObjectFasilitasFk")
	@Caption(value="Object fasilitas")
	private GenericView fasilitas;

	@Column(name = "ObjectFasilitasFk", insertable = false, updatable = false, nullable = false)
	private Integer fasilitasId;

	@ManyToOne
	@JoinColumn(name = "ObjectTenagaFk")
	@Caption(value="Object tenaga")
	private GenericView tenaga;

	@Column(name = "ObjectTenagaFk", insertable = false, updatable = false, nullable = false)
	private Integer tenagaId;

	@NotNull(message = "keterangan tidak boleh kosong")
	@Column(name = "keterangan")
	@Caption(value = "keterangan")
	private String keterangan;
	
	@NotNull(message = "isKondisiPasien tidak boleh kosong")
	@Column(name = "isKondisiPasien")
	@Caption(value = "isKondisiPasien")
	private Boolean isKondisiPasien;
	
	@NotNull(message = "isFasilitas tidak boleh kosong")
	@Column(name = "isFasilitas")
	@Caption(value = "isFasilitas")
	private Boolean isFasilitas;

	@NotNull(message = "isTenaga tidak boleh kosong")
	@Column(name = "isTenaga")
	@Caption(value = "isTenaga")
	private Boolean isTenaga;
	
	@NotNull(message = "isLainLain tidak boleh kosong")
	@Column(name = "isLainLain")
	@Caption(value = "isLainLain")
	private Boolean isLainLain;
	
	@NotNull(message = "isPasienDiberitahu tidak boleh kosong")
	@Column(name = "isPasienDiberitahu")
	@Caption(value = "isPasienDiberitahu")
	private Boolean isPasienDiberitahu;
	
	@NotNull(message = "isKeluargaPasienDiberitahu tidak boleh kosong")
	@Column(name = "isKeluargaPasienDiberitahu")
	@Caption(value = "isKeluargaPasienDiberitahu")
	private Boolean isKeluargaPasienDiberitahu;
	
	@NotNull(message = "namaKeluargaPasien tidak boleh kosong")
	@Column(name = "namaKeluargaPasien")
	@Caption(value = "namaKeluargaPasien")
	private String namaKeluargaPasien;

	@ManyToOne
	@JoinColumn(name = "ObjectKesadaranFk")
	@Caption(value="Object Kesadaran")
	private HubunganKeluarga hubunganKeluarga;
	
	@OneToMany(mappedBy="papInstruksiRanap")
	@Caption(value="Object PapPetugasPendamping")
	private Set<PapPetugasPendamping> papPetugasPendampingSet=new HashSet<PapPetugasPendamping>();
	
	public GenericView getKondisiPasien() {
		return kondisiPasien;
	}
	public void setKondisiPasien(GenericView kondisiPasien) {
		this.kondisiPasien = kondisiPasien;
	}
	public GenericView getFasilitas() {
		return fasilitas;
	}
	public void setFasilitas(GenericView fasilitas) {
		this.fasilitas = fasilitas;
	}
	public GenericView getTenaga() {
		return tenaga;
	}
	public void setTenaga(GenericView tenaga) {
		this.tenaga = tenaga;
	}
	public String getKeterangan() {
		return keterangan;
	}
	public void setKeterangan(String keterangan) {
		this.keterangan = keterangan;
	}
	public Boolean getIsPasienDiberitahu() {
		return isPasienDiberitahu;
	}
	public void setIsPasienDiberitahu(Boolean isPasienDiberitahu) {
		this.isPasienDiberitahu = isPasienDiberitahu;
	}
	public Boolean getIsKeluargaPasienDiberitahu() {
		return isKeluargaPasienDiberitahu;
	}
	public void setIsKeluargaPasienDiberitahu(Boolean isKeluargaPasienDiberitahu) {
		this.isKeluargaPasienDiberitahu = isKeluargaPasienDiberitahu;
	}
	public String getNamaKeluargaPasien() {
		return namaKeluargaPasien;
	}
	public void setNamaKeluargaPasien(String namaKeluargaPasien) {
		this.namaKeluargaPasien = namaKeluargaPasien;
	}
	public HubunganKeluarga getHubunganKeluarga() {
		return hubunganKeluarga;
	}
	public void setHubunganKeluarga(HubunganKeluarga hubunganKeluarga) {
		this.hubunganKeluarga = hubunganKeluarga;
	}
	public RegistrasiPelayananPasien getRegistrasiPelayananPasien() {
		return registrasiPelayananPasien;
	}
	public void setRegistrasiPelayananPasien(RegistrasiPelayananPasien registrasiPelayananPasien) {
		this.registrasiPelayananPasien = registrasiPelayananPasien;
	}
	public Pasien getPasien() {
		return pasien;
	}
	public void setPasien(Pasien pasien) {
		this.pasien = pasien;
	}
	public Date getTglInput() {
		return tglInput;
	}
	public void setTglInput(Date tglInput) {
		this.tglInput = tglInput;
	}
	public Boolean getIsFasilitas() {
		return isFasilitas;
	}
	public void setIsFasilitas(Boolean isFasilitas) {
		this.isFasilitas = isFasilitas;
	}
	public Boolean getIsTenaga() {
		return isTenaga;
	}
	public void setIsTenaga(Boolean isTenaga) {
		this.isTenaga = isTenaga;
	}
	public Boolean getIsLainLain() {
		return isLainLain;
	}
	public void setIsLainLain(Boolean isLainLain) {
		this.isLainLain = isLainLain;
	}
	
}
